Index: trunk/ab5.0/ablib/src/Classes/System/Threading/Exception.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Threading/Exception.ab	(revision 563)
+++ trunk/ab5.0/ablib/src/Classes/System/Threading/Exception.ab	(revision 566)
@@ -6,11 +6,11 @@
 Public'constructor
 	Sub AbandonedMutexException()
-		This.SystemException("", Nothing)
+		SystemException("", Nothing)
 	End Sub
 	Sub AbandonedMutexException(message As String)
-		This.SystemException(message, Nothing)
+		SystemException(message, Nothing)
 	End Sub
 	Sub AbandonedMutexException(message As String, innerException As Exception)
-		This.SystemException(message, innerException)
+		SystemException(message, innerException)
 	End Sub
 
@@ -21,13 +21,13 @@
 Public'constructor
 	Sub SemaphoreFullException()
-		This.SystemException("Too many semaphore countors.", Nothing)
+		SystemException("Too many semaphore countors.", Nothing)
 		This.HResult = ERROR_TOO_MANY_SEMAPHORES
 	End Sub
 	Sub SemaphoreFullException(message As String)
-		This.SystemException(message, Nothing)
+		SystemException(message, Nothing)
 		This.HResult = ERROR_TOO_MANY_SEMAPHORES
 	End Sub
 	Sub SemaphoreFullException(message As String, innerException As Exception)
-		This.SystemException(message, innerException)
+		SystemException(message, innerException)
 		This.HResult = ERROR_TOO_MANY_SEMAPHORES
 	End Sub
@@ -38,11 +38,11 @@
 Public'constructor
 	Sub SynchronizationLockException()
-		This.SystemException("", Nothing)
+		SystemException("", Nothing)
 	End Sub
 	Sub SynchronizationLockException(message As String)
-		This.SystemException(message, Nothing)
+		SystemException(message, Nothing)
 	End Sub
 	Sub SynchronizationLockException(message As String, innerException As Exception)
-		This.SystemException(message, innerException)
+		SystemException(message, innerException)
 	End Sub
 End Class
@@ -52,11 +52,11 @@
 Public'constructor
 	Sub ThreadAbortException()
-		This.SystemException("The thread was discontinued.", Nothing)
+		SystemException("The thread was discontinued.", Nothing)
 	End Sub
 	Sub ThreadAbortException(message As String)
-		This.SystemException(message, Nothing)
+		SystemException(message, Nothing)
 	End Sub
 	Sub ThreadAbortException(message As String, innerException As Exception)
-		This.SystemException(message, innerException)
+		SystemException(message, innerException)
 	End Sub
 End Class
@@ -66,11 +66,11 @@
 Public'constructor
 	Sub ThreadInterruptedException()
-		This.SystemException("The thread was Interrupted.", Nothing)
+		SystemException("The thread was Interrupted.", Nothing)
 	End Sub
 	Sub ThreadInterruptedException(message As String)
-		This.SystemException(message, Nothing)
+		SystemException(message, Nothing)
 	End Sub
 	Sub ThreadInterruptedException(message As String, innerException As Exception)
-		This.SystemException(message, innerException)
+		SystemException(message, innerException)
 	End Sub
 End Class
@@ -80,11 +80,11 @@
 Public'constructor
 	Sub ThreadStartException()
-		This.SystemException("The thread cannot be begun.", Nothing)
+		SystemException("The thread cannot be begun.", Nothing)
 	End Sub
 	Sub ThreadStartException(message As String)
-		This.SystemException(message, Nothing)
+		SystemException(message, Nothing)
 	End Sub
 	Sub ThreadStartException(message As String, innerException As Exception)
-		This.SystemException(message, innerException)
+		SystemException(message, innerException)
 	End Sub
 End Class
@@ -94,11 +94,11 @@
 Public'constructor
 	Sub WaitHandleCannotBeOpenedException()
-		This.SystemException("The wait handle can not be opened.", Nothing)
+		SystemException("The wait handle can not be opened.", Nothing)
 	End Sub
 	Sub WaitHandleCannotBeOpenedException(message As String)
-		This.SystemException(message, Nothing)
+		SystemException(message, Nothing)
 	End Sub
 	Sub WaitHandleCannotBeOpenedException(message As String, innerException As Exception)
-		This.SystemException(message, innerException)
+		SystemException(message, innerException)
 	End Sub
 End Class